
//digital_clock
////////////////////////////////////////////////////////////////////////////////
char e0=1, e1=1, e2=1, e3=1, select=0, select_time=0;
char horas = 0, minutos = 0,  segundos = 0;
////////////////////////////////////////////////////////////////////////////////

void set_up() {   //function for pic16f887

  ANSEL = 0;      //all the pins are configured as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;    //analog comparators off.
  C2ON_bit = 0;
  CCP1CON = 0;   //PWM1 y PWM2 off.
  CCP2CON = 0;
  TRISB = 0;
  TRISD = 0;
  TRISC = 0xF0;   //RC7, RC6, RC5 and RC4 are configured as digital inputs
  PORTB = 0;     //clear Ports B, C and D
  PORTC = 0;
  PORTD = 0;
}
////////////////////////////////////////////////////////////////////////////////
void reloj() {

unsigned char ch0, ch1, ch2, ch3, ch4, ch5;
unsigned char display[10] = {63,6,91,79,102,109,125,7,127,103};
short int i=0;
for(i=0; i<=86; i++){  // aprox 1 seg
ch0 = horas/10;
PORTD = 1;
PORTB = display[ch0] ;
delay_ms(2);             //Hours
ch1 = horas%10;
PORTD = 2;
PORTB = display[ch1] ;
delay_ms(2);
ch2 = minutos/10;
PORTD = 4;              //Minutes
PORTB = display[ch2] ;
delay_ms(2);
ch3=  minutos%10;
PORTD = 8;
PORTB = display[ch3] ;
delay_ms(2);
ch4 = segundos/10;
PORTD = 16;              //Seconds
PORTB = display[ch4] ;
delay_ms(2);
ch5 = segundos%10;
PORTD = 32;
PORTB = display[ch5] ;
delay_ms(2);
}
}
////////////////////////////////////////////////////////////////////////////////
void main() {
  set_up();
  do {
       reloj();
       segundos++;
       if(segundos>59) segundos=0, minutos++;
       if(minutos>59) minutos=0,  horas++;
       if(horas>23) horas=0;

       if (Button(&PORTC,6,1,0)) e1=0;     //if the button has been pushed
       if (e1==0 && Button(&PORTC,6,1,1)){ //and if after that the button is free
        minutos++;                          //then increase minutos
       if (minutos>59) minutos=0;
       segundos=0;
        e1=1;
       }
       if (Button(&PORTC,7,1,0)) e0=0;     //if the button has been pushed
       if (e0==0 && Button(&PORTC,7,1,1)){ //and if after that the button is free
        minutos--;                          //then decrease minutos
       if (minutos==255) minutos=59;       // -1=255 >>>>> 0
        segundos=0;
       e0=1;
       }
       if (Button(&PORTC,4,1,0)) e2=0;       //if the button has been pushed
       if (e2==0 && Button(&PORTC,4,1,1)){ //and if after that the button is free
        horas++;                            //then increase horas
       if (horas>23) horas=0;
        segundos=0;
       e2=1;
       }
       if (Button(&PORTC,5,1,0)) e3=0;     //if the button has been pushed
       if (e3==0 && Button(&PORTC,5,1,1)){ //and if after that the button is free
         horas--;                            //then decrease horas
       if (horas==255) horas=23;          // -1=255 >>>>> 0
        segundos=0;
          e3=1;
       }
     } while(1);
 } //END.
////////////////////////////////////////////////////////////////////////////////